unit unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, StrUtils, Clipbrd, Vcl.Buttons,
  Vcl.ExtDlgs;

type
  TForm1 = class(TForm)
    btnConnectClick: TButton;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Image1: TImage;
    Button5: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Button6: TButton;
    ListBox1: TListBox;
    procedure btnConnectClickClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button6Click(Sender: TObject);
  private
    { Private 錾 }

  public
    { Public 錾 }

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}
uses
  ocv.core_c, ocv.core.types_c, ocv.imgproc_c, ocv.imgproc.types_c,
  ocv.objdetect_c;

const
  WM_CAP_DRIVER_CONNECT           = WM_USER + 10;
  WM_CAP_DRIVER_DISCONNECT        = WM_USER + 11;
  WM_CAP_FILE_SET_CAPTURE_FILEA   = WM_USER + 20;
  WM_CAP_SAVEDIB                  = WM_USER + 25;
  WM_CAP_SEQUENCE                 = WM_USER + 62;
  WM_CAP_GRAB_FRAME               = WM_USER + 60;
  WM_CAP_SEQUENCE_NOFILE          = WM_USER + 63;
  WM_CAP_EDIT_COPY                = WM_USER + 30;
  WM_CAP_SET_OVERLAY              = WM_USER + 51;
  WM_CAP_SET_SCALE                = WM_USER + 53;
  WM_CAP_SET_PREVIEWRATE          = WM_USER + 52;
  WM_CAP_SET_PREVIEW              = WM_USER + 50;
  WM_CAP_STOP                     = WM_USER + 68;

  WM_CAP_SET_CALLBACK_VIDEOSTREAM = WM_USER + 6;
  WM_CAP_SET_CALLBACK_ERROR       = WM_USER + 2;
  WM_CAP_SET_CALLBACK_STATUSA     = WM_USER + 3;
  WM_CAP_SET_CALLBACK_FRAME       = WM_USER + 5;
  WM_CAP_GET_VIDEOFORMAT          = WM_USER + 44;
  WM_CAP_SET_VIDEOFORMAT          = WM_USER + 45;

  WM_CAP_DLG_VIDEOSOURCE          = WM_USER + 42;
  WM_CAP_DLG_VIDEOFORMAT          = WM_USER + 41;
  WM_CAP_DLG_VIDEODISPLAY         = WM_USER + 43;


var
  CaptureWnd   : HWND;
  Filename     : ansistring;
  lpBmpInfo    : Bitmapinfo;
  Xml: ansistring;
  Cascade2: PCvHaarClassifierCascade;
  Storage: PCvMemStorage;

const
  str_Connect = 'WebJɐڑ';
  str_Disconn = 'ڑ';
  CaptureLeft     = 160;
  CaptureTop      = 8;
  // webJɍ킹Đݒ肵܂
  CaptureWidth    = 1280;     // ok
  CaptureHeight   = 720;

//  CaptureWidth    = 640;      // ok
//  CaptureHeight   = 480;

//  CaptureWidth    = 640;      // ok
//  CaptureHeight   = 360;

// ̃TCY͓삵Ȃs
// obt@TCYmۂłȂ̂
//  CaptureWidth    = 1280;     // NG
//  CaptureHeight   = 960;

function capCreateCaptureWindow(WindowName: PChar;
    dwStyle: Cardinal; x,y, nWidth,nHeight: Integer;
    ParentWin: HWnd; nID: Integer): HWnd; stdcall;
     external 'AVICAP32.DLL' name 'capCreateCaptureWindowW';


function capGetDriverDescription(wDriverIndex: DWORD;
    lpszName: LPWSTR; cbName : integer;
    lpszVer : LPWSTR; cbVer  : Integer): Boolean; stdcall;
     external 'AVICAP32.DLL' name 'capGetDriverDescriptionW';

{-----------------------------------------------------------------------------
  Procedure:  BitmapToIplImage
  Arguments:  iplImg: PIplImage; bitmap: TBitmap
  Description: create a new IplImage and convert a Windows bitmap (24bit) to it
-----------------------------------------------------------------------------}
procedure BitmapToIplImage(iplImg: PIplImage; bitmap: TBitmap);
var
  dataByte: PByte;
//  dataByte: pByteArray;
  RowIn: pByte;
//  RowIn: pByteArray;
  j : integer;
  offset: integer;
begin
  try
    // 24rbgtH[}bg̊mF
    assert((iplImg.Depth = 8) and (iplImg.NChannels = 3),
//    assert((iplImg.Depth = 8) and (iplImg.NChannels = 4),
            'Bitmap2IplImage: Not a 24 bit color iplImage!');
    assert((bitmap.pixelFormat = pf24bit),
//    assert((bitmap.pixelFormat = pfdevice),
            'Bitmap2IplImage: Not a 24 bit color BMP bitmap!');
    // 摜̐擪Cݒ
    iplimg.Origin := IPL_ORIGIN_TL;
//    iplimg.Origin := IPL_ORIGIN_BL;
    iplImg.ChannelSeq := 'BGR';
    // 摜f[^[̃Rs[
    for j := 0 to Bitmap.Height - 1 do begin
      RowIn := Bitmap.Scanline[j];
      offset := integer(iplimg.ImageData) + iplImg.WidthStep * j;
      dataByte := pbyte(offset);
      CopyMemory(dataByte, rowin, iplImg.WidthStep);
    end;

//    RowIn := Bitmap.Scanline[bitmap.height - 1];
//    dataByte := pbytearray(iplimg.ImageData);
  {direct copy of the bitmap row bytes to iplImage rows}
//    CopyMemory(dataByte, rowin, iplimg.ImageSize);
  except

  end;
end;

procedure TForm1.btnConnectClickClick(Sender: TObject);
begin
  if (Sender as TButton).Caption = str_Connect then begin
    // foCX̐ݒƃnh̎擾
    CaptureWnd := capCreateCaptureWindow('Window',
        WS_CHILD or WS_VISIBLE, CaptureLeft, CaptureTop,
        CaptureWidth, CaptureHeight, Handle, 0);
    if CaptureWnd <> 0 then begin
//      SendMessage(CaptureWnd, WM_CAP_SET_CALLBACK_VIDEOSTREAM, 0, 0);
//      SendMessage(CaptureWnd, WM_CAP_SET_CALLBACK_ERROR, 0, 0);
//      SendMessage(CaptureWnd, WM_CAP_SET_CALLBACK_STATUSA, 0, 0);

      //foCXւ̐ڑ
      SendMessage(CaptureWnd, WM_CAP_DRIVER_CONNECT, 0, 0);

      // J摜̒
//      SendMessage(CaptureWnd, WM_CAP_DLG_VIDEOSOURCE, 0, 0);

      // J̉𑜓xƃtH[}bg̎w
      // WM_CAP_DLG_VIDEOFORMAT́A4:3 ōőTCY640~480łB
//      SendMessage(CaptureWnd, WM_CAP_DLG_VIDEOFORMAT, 0, 0);

      // Video tH[}bg̎擾
      SendMessage(CaptureWnd, WM_CAP_GET_VIDEOFORMAT, sizeof(lpBmpInfo), Cardinal(@lpBmpInfo));
      // 𑜓x̐ݒ
      with lpbmpInfo.bmiHeader do begin
        biWidth := CaptureWidth;
        biHeight := CaptureHeight;
        biSizeImage := biWidth * biHeight * biBitCount div 8;
//        biCompression := BI_RGB;
      end;
      // Video tH[}bg̐ݒ
      SendMessage(CaptureWnd, WM_CAP_SET_VIDEOFORMAT, sizeof(lpBmpInfo), Cardinal(@lpBmpInfo));

      //vr[XP[ ϔ{Lݒ
      SendMessage(CaptureWnd, WM_CAP_SET_SCALE, 1, 0);
      //vr[̃R}i~bj
      SendMessage(CaptureWnd, WM_CAP_SET_PREVIEWRATE, 35, 0);

      // \TCY̎w
      SetWindowPos(CaptureWnd, HWND_BOTTOM, 0, 0,
           CaptureWidth div 2, CaptureHeight div 2,
           SWP_NOMOVE or SWP_NOZORDER);

      // vr[Jn
      SendMessage(CaptureWnd, WM_CAP_SET_PREVIEW, 1, 0);
    end;
    (Sender as TButton).Caption:= str_Disconn
  end
  else begin
    if CaptureWnd <> 0 then begin
      // foCXւ̐ڑ
      SendMessage(CaptureWnd, WM_CAP_DRIVER_DISCONNECT, 0, 0);
      // Capture悤Window̔j
      DestroyWindow(CaptureWnd);
      // nh̃NA
      CaptureWnd := 0;
      (Sender as TButton).Caption:= str_Connect;
    end;
  end;
end;

// Nbv{[hփRs[
procedure TForm1.Button1Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then
    SendMessage(CaptureWnd, WM_CAP_EDIT_COPY, 1, 0 );
end;

// t@C֕ۑ
// SendMessageőt@CAnsiString̕Kv܂B
procedure TForm1.Button2Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then begin
    SavePictureDialog1.Filter := '摜t@C|*.bmp';
    if SavePictureDialog1.Execute then begin
      Filename := ansistring(ChangeFileExt(SavePictureDialog1.FileName,'.bmp'));
    end
    else exit;
    SendMessage(CaptureWnd, WM_CAP_SAVEDIB, 0, Cardinal(pAnsiChar(Filename)));
  end;
end;

// t@Cւ̓ۑJn
// SendMessageőt@CAnsiString̕Kv܂B
procedure TForm1.Button3Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then begin
    SavePictureDialog1.Filter := 't@C|*.avi';
    if SavePictureDialog1.Execute then begin
      Filename := ansistring(ChangeFileExt(SavePictureDialog1.FileName,'.avi'));
    end
    else exit;
    SendMessage(CaptureWnd, WM_CAP_FILE_SET_CAPTURE_FILEA, 0, Cardinal(pAnsichar (Filename)));
    SendMessage(CaptureWnd, WM_CAP_SEQUENCE, 0, 0);
  end;
end;

// ۑ̒~
procedure TForm1.Button4Click(Sender: TObject);
begin
  if CaptureWnd <> 0 then
    SendMessage(CaptureWnd, WM_CAP_STOP, 0, 0);
end;

// Nbv{[h摜\t  猟o
procedure TForm1.Button5Click(Sender: TObject);
var
  bitmm: TPicture;
  frame, fgray : PIplImage;
  faces: PCvSeq;
  pt1, pt2: TCvPoint2D32f;
  i : integer;
  r: PCvRect;
begin
  if Clipboard.HasFormat(CF_DIB) then begin
    bitmm := TPicture.Create;
    try
      // Nbv{[h摜擾
      bitmm.Bitmap.Assign(Clipboard);
      // ftHgpfDevice (pf32bit)
      // 24rbgtH[}bgɕϊ
      bitmm.Bitmap.PixelFormat := pf24bit;
      // Opencv IplImage 24rbgtH[}bgݒ
      frame := cvCreateImage(cvSize(bitmm.Bitmap.Width, bitmm.Bitmap.Height), IPL_DEPTH_8U, 3);
//      frame := cvCreateImage(cvSize(bitmm.Bitmap.Width, bitmm.Bitmap.Height), IPL_DEPTH_8U, 4);
//      frame.Origin := IPL_ORIGIN_BL;
      // bitmap to IplImage ϊ
      BitmapToIplImage(frame, bitmm.Bitmap);
      // J[O[ϊ
      fgray := cvCreateImage(cvGetSize (frame), IPL_DEPTH_8U, 1);
      cvCvtColor(frame, fgray, CV_BGR2GRAY);
      // O[qXgO
      cvEqualizeHist(fgray, fgray);

      //Xg[WNA
	    cvClearMemStorage(Storage);
      // 摜畨̌o
	    faces := cvHaarDetectObjects(fgray, Cascade2, Storage, 1.2, 3,
                                    CV_HAAR_DO_CANNY_PRUNING, CvSize(50, 50), CvSize(0, 0));
	    bitmm.Bitmap.Canvas.Pen.Color	:= clRed;
	    bitmm.Bitmap.Canvas.Pen.Width	:= 4;
	    bitmm.Bitmap.Canvas.Brush.Style:= bsClear;
	    for i := 0 to faces.total - 1 do begin
		    r		:= PCvRect(cvGetSeqElem(Faces, i));
		    pt1.x	:= r.x;
		    pt2.x	:= r.x + r.width;
		    pt1.y	:= r.y;
		    pt2.y	:= r.y + r.height;
        // ``
		    bitmm.Bitmap.Canvas.Rectangle(Round(pt1.x),Round(pt1.y), Round(pt2.x), Round(pt2.y));
	    end;

      Image1.Canvas.StretchDraw(rect(0, 0, CaptureWidth div 4, CaptureHeight div 4), bitmm.Bitmap);
    finally
      bitmm.Free;
    end;
  end;
end;

// hCo[o[W̎擾
procedure TForm1.Button6Click(Sender: TObject);
var Indx : Cardinal;
    szName,
    szVersion: array[0..MAX_PATH] of Char;
begin
  ListBox1.Clear;
  for Indx := 0 to 9 do begin
    if capGetDriverDescription(Indx, @szName, sizeof(szName), @szVersion, sizeof(szVersion)) then begin
      ListBox1.Items.Add(szName + ' (' + szVersion + ')');
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  top := (screen.Height - Height) div 2;
  left := (screen.Width - Width) div 2;
  btnConnectClick.Caption := str_Connect;
  CaptureWnd := 0;
	Storage := cvCreateMemStorage(0);
	Xml := 'haarcascade_frontalface_alt.xml';
//	Xml := 'haarcascade_frontalface_default.xml';  // default
	Cascade2 := PCvHaarClassifierCascade(cvLoad(PAnsiChar(Xml), nil, nil, nil ));
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if CaptureWnd <> 0 then begin
    SendMessage(CaptureWnd, WM_CAP_DRIVER_DISCONNECT, 0, 0);
    DestroyWindow(CaptureWnd);
  end;
end;

end.


